OpenTTD Source: GraphicsSet Struct Reference

OpenTTD Source 14.1

Public Member Functions | Static Public Member Functions | Data Fields | Private Attributes
GraphicsSet Struct Reference

All data of a graphics set. More...

`#include <base_media_base.h>`

Inheritance diagram for GraphicsSet:

## Public Member Functions
bool | FillSetDetails (const IniFile &ini, const std::string &path, const std::string &full_filename)
GRFConfig * | GetExtraConfig () const
GRFConfig & | GetOrCreateExtraConfig () const
| Return configuration for the extra GRF, or lazily create it. More...
bool | IsConfigurable () const
void | CopyCompatibleConfig (const GraphicsSet &src)
Public Member Functions inherited from BaseSet< GraphicsSet, MAX_GFT, true >
| ~BaseSet ()
| Free everything we allocated.
int | GetNumMissing () const
| Get the number of missing files. More...
int | GetNumInvalid () const
| Get the number of invalid files. More...
bool | FillSetDetails (const IniFile &ini, const std::string &path, const std::string &full_filename, bool allow_empty_filename=true)
| Read the set information from a loaded ini. More...
void | CopyCompatibleConfig ([[maybe_unused]] const GraphicsSet &src)
const std::string & | GetDescription (const std::string &isocode) const
| Get the description for the given ISO code. More...
std::string | GetListLabel () const
| Get string to use when listing this set in the settings window. More...
std::optional< std::string > | GetTextfile (TextfileType type) const
| Search a textfile file next to this base media. More...

## Static Public Member Functions
static MD5File::ChecksumResult | CheckMD5 (const MD5File *file, Subdirectory subdir)
| Calculate and check the MD5 hash of the supplied GRF. More...
Static Public Member Functions inherited from BaseSet< GraphicsSet, MAX_GFT, true >
static MD5File::ChecksumResult | CheckMD5 (const MD5File *file, Subdirectory subdir)
| Calculate and check the MD5 hash of the supplied file. More...

## Data Fields
PaletteType | palette
| Palette of this graphics set.
BlitterType | blitter
| Blitter of this graphics set.
Data Fields inherited from BaseSet< GraphicsSet, MAX_GFT, true >
std::string | name
| The name of the base set.
std::string | url
| URL for information about the base set.
TranslatedStrings | description
| Description of the base set.
uint32_t | shortname
| Four letter short variant of the name.
uint32_t | version
| The version of this base set.
bool | fallback
| This set is a fallback set, i.e. it should be used only as last resort.
MD5File | files [NUM_FILES]
| All files part of this set.
uint | found_files
| Number of the files that could be found.
uint | valid_files
| Number of the files that could be found and are valid.
GraphicsSet * | next
| The next base set in this list.

## Private Attributes
std::unique_ptr< GRFConfig > | extra_cfg
| Parameters for extra GRF.

## Additional Inherited Members
Public Types inherited from BaseSet< GraphicsSet, MAX_GFT, true >
typedef std::unordered_map< std::string, std::string > | TranslatedStrings
Static Public Attributes inherited from BaseSet< GraphicsSet, MAX_GFT, true >
static const size_t | NUM_FILES
| Number of files in this set.
static const bool | SEARCH_IN_TARS
| Whether to search in the tars or not.
static const char *const * | file_names
| Internal names of the files in this set. More...

## Detailed Description

All data of a graphics set.

Definition at line 260 of file base_media_base.h.

## Member Function Documentation

## ◆ CheckMD5()

MD5File::ChecksumResult GraphicsSet::CheckMD5 | ( | const MD5File * | file,
|  | Subdirectory | subdir
| ) |  |
| static

Calculate and check the MD5 hash of the supplied GRF.

Parameters

  file | The file get the hash of.
  subdir | The sub directory to get the files from.

Returns
  - #CR_MATCH if the MD5 hash matches
  - #CR_MISMATCH if the MD5 does not match
  - #CR_NO_FILE if the file misses

Definition at line 419 of file gfxinit.cpp.

References MD5File::CheckMD5(), MD5File::CR_NO_FILE, MD5File::filename, FioFCloseFile(), FioFOpenFile(), and GRFGetSizeOfDataSection().

Referenced by CheckExternalFiles().

## ◆ GetOrCreateExtraConfig()

GRFConfig & GraphicsSet::GetOrCreateExtraConfig | ( |  | ) | const

Return configuration for the extra GRF, or lazily create it.

Returns
  NewGRF configuration

Definition at line 374 of file gfxinit.cpp.

References BASESET_DIR, extra_cfg, BaseSet< GraphicsSet, MAX_GFT, true >::files, FillGRFDetails(), GFT_EXTRA, GRFP_GRF_DOS, GRFP_GRF_WINDOWS, PAL_DOS, PAL_WINDOWS, and palette.

The documentation for this struct was generated from the following files:

- src/base_media_base.h
- src/gfxinit.cpp